#ifndef GLOBAL_H_INCLUDED
#define GLOBAL_H_INCLUDED

// libraries needed for OpenGL drawing
#include <SDL.h>
#include <SDL_image.h>
#include <SDL_opengl.h>
#include <math.h>

// debugging or release?
//#define DEBUG

#ifdef DEBUG
#define BIRDSEYE
//#define SIDEON
#endif

// settings
#define SUN_X 25.0
#define SUN_Y 70.0
#define SUN_Z 25.0

#ifndef DEBUG
#define VISIBLE_DISTANCE 100.0
#define SUN_INTENSITY 0.7
#else
#define VISIBLE_DISTANCE 200.0
#define SUN_INTENSITY 0.9
#endif

// constants
const GLfloat PI = 3.14159265;

// size of display area
const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;

#endif
