#ifndef TEXTURES_H_INCLUDED
#define TEXTURES_H_INCLUDED
#include "global.h"

class Texture
{
    private:
        // the opengl number of the texture
        GLuint tex;
        // the corner coords of the texture
        GLfloat minx, maxx;
        GLfloat miny, maxy;
    public:
        // create a new texture
        Texture(GLuint tex, GLfloat minx, GLfloat miny, 
            GLfloat maxx, GLfloat maxy): tex(tex), minx(minx), miny(miny),
            maxx(maxx), maxy(maxy) {}
        // load a new texture
        Texture(const char *file);
        // destroy
        ~Texture();
        // start using
        void Begin() { 
            glBindTexture(GL_TEXTURE_2D, tex);
            glEnable(GL_TEXTURE_2D);
        }
        // stop using
        void End() {
            glDisable(GL_TEXTURE_2D);
        }
        // diamensions
        inline GLfloat maxX() { return maxx; }
        inline GLfloat minX() { return minx; }
        inline GLfloat maxY() { return maxy; }
        inline GLfloat minY() { return miny; }
};

#endif
